#include <WiFi.h>
#include <PubSubClient.h>



/****************************************
 * Define Constants
 ****************************************/
namespace {
  const char * WIFISSID = "Vodafone_ADSL_"; // Put your WifiSSID here
  const char *  PASSWORD = "EVER101024093622"; // Put your wifi password here
  const char * TOKEN = "A1E-cCuErTjvGp2iKNbAE1RVxtt2BWZPvc"; // Put your Ubidots' TOKEN
  const char * MQTT_CLIENT_NAME = "LWnKdZ3QeJ"; // MQTT client Name, please enter your own 8-12 alphanumeric character ASCII string; 
  const char * VARIABLE_LABEL_1 = "humidity"; // Assign the variable label
  const char * VARIABLE_LABEL_2 = "temperature"; // Assign the variable label
  const char * DEVICE_LABEL = "esp32"; // Assign the device label
  const char * MQTT_BROKER = "things.ubidots.com";   
}


/* Space to store the request */
char payload[300];
char topic[150];
/* Space to store values to send */
char str_TempSensor[10];
char str_HumSensor[10];

/****************************************
 * Auxiliar Functions
 ****************************************/
WiFiClient ubidots;
PubSubClient client(ubidots);

void callback(char* topic, byte* payload, unsigned int length) {
  char p[length + 1];
  memcpy(p, payload, length);
  p[length] = NULL;
  String message(p);
  Serial.write(payload, length);
  Serial.println(topic);
}

void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    Serial.println("Attempting MQTT connection...");
    
    // Attemp to connect
    if (client.connect(MQTT_CLIENT_NAME, TOKEN, "")) {
      Serial.println("Connected");
    } else {
      Serial.print("Failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 2 seconds");
      // Wait 2 seconds before retrying
      delay(2000);
    }
  }
}



/****************************************
 * Main Functions
 ****************************************/
void setup() {
  Serial.begin(115200);
  WiFi.begin(WIFISSID, PASSWORD);
  Serial.println();
  Serial.print("Wait for WiFi...");
  
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(500);
  }
  
  Serial.println("");
  Serial.println("WiFi Connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  client.setServer(MQTT_BROKER, 1883);
  client.setCallback(callback);  
}

void loop() {
  if (!client.connected()) {
    reconnect();
  }
  
  /* Reading temperature and humidity */
  float humidity = random(0,100);
  float temperature = random(20,200);  
  
  /* 4 is mininum width, 2 is precision; float value is copied onto str_sensor*/
  dtostrf(humidity, 4, 2, str_HumSensor);
  dtostrf(temperature, 4, 2, str_TempSensor);
  
  /* Building the Ubidots request */
  sprintf(topic, "%s%s", "/v1.6/devices/", DEVICE_LABEL);
  sprintf(payload, "%s", ""); // Cleans the payload
  sprintf(payload, "%s\"%s\": %s,", payload, VARIABLE_LABEL_1, str_HumSensor); // Adds the variable label
  sprintf(payload, "%s\"%s\": %s}", payload, VARIABLE_LABEL_2, str_TempSensor); // Adds the variable label
    
  //sprintf(payload, "%s {\"value\": %s}}", payload, str_sensor); 

  /* Print the sensor reading to the Serial Monitor */
  Serial.println("Publishing values to Ubidots Cloud");
  Serial.print("Humidity = ");
  Serial.println(humidity);
  Serial.print("Temperature = ");
  Serial.println(temperature);
  
  /* Publish the request to Ubidots */
   client.publish(topic, payload);
  client.loop();
  delay(1000);
}
